From 32ae4f384b5465df7050fff7e3a75b5f2040d318 Mon Sep 17 00:00:00 2001
From: Francois-Rene Rideau <fare@tunes.org>
Date: Thu, 27 Oct 2011 15:48:26 -0400
Subject: [PATCH 3/3] Quick fix to allow send-service-unavailable-reply to work at all,
 by creating a fake acceptor/stream/request/reply context for it.
 A better fix is needed.

---
 taskmaster.lisp |   27 ++++++++++++++++++++++-----
 1 files changed, 22 insertions(+), 5 deletions(-)

diff --git a/taskmaster.lisp b/taskmaster.lisp
index 532218b..bac9b57 100644
--- a/taskmaster.lisp
+++ b/taskmaster.lisp
@@ -318,11 +318,28 @@ implementations."))
 (defun send-service-unavailable-reply (taskmaster socket)
   "A helper function to send out a quick error reply, before any state
 is set up via PROCESS-REQUEST."
-  (let ((acceptor (taskmaster-acceptor taskmaster)))
-    (send-response acceptor
-                   (initialize-connection-stream acceptor (make-socket-stream socket acceptor))
-                   +http-service-unavailable+
-                   :content (acceptor-status-message acceptor +http-service-unavailable+))))
+  (let* ((acceptor (taskmaster-acceptor taskmaster))
+         (*acceptor* acceptor)
+         (*hunchentoot-stream*
+          (initialize-connection-stream acceptor (make-socket-stream socket acceptor)))
+         (*reply* (make-instance (acceptor-reply-class acceptor)))
+         (*request*
+          (multiple-value-bind (remote-addr remote-port)
+              (get-peer-address-and-port socket)
+            (make-instance (acceptor-request-class acceptor)
+              :acceptor acceptor
+              :remote-addr remote-addr
+              :remote-port remote-port
+              :headers-in nil
+              :content-stream nil
+              :method nil
+              :uri nil
+              :server-protocol nil))))
+    (with-character-stream-semantics
+      (send-response acceptor
+                     (flex:make-flexi-stream *hunchentoot-stream* :external-format :iso-8859-1)
+                     +http-service-unavailable+
+                     :content (acceptor-status-message acceptor +http-service-unavailable+)))))
 
 #-:lispworks
 (defun client-as-string (socket)
-- 
1.7.2.5

